/**
 * Generated by Apache Royale Compiler from org/apache/royale/collections/IArrayListView.as
 * org.apache.royale.collections.IArrayListView
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.collections.IArrayListView');

goog.require('org.apache.royale.collections.ISort');
goog.require('org.apache.royale.collections.ICollectionView');



/**
 * @interface
 * @extends {org.apache.royale.collections.ICollectionView}
 */
org.apache.royale.collections.IArrayListView = function() {
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.collections.IArrayListView', org.apache.royale.collections.IArrayListView);
/**  * @type {Function}
 */org.apache.royale.collections.IArrayListView.prototype.filterFunction;
/**  * @type {org.apache.royale.collections.ISort}
 */org.apache.royale.collections.IArrayListView.prototype.sort;
/**
 *  Returns whether the view contains the specified object.
 *  If the view has a filter applied to it this method may return
 *  <code>false</code> even if the underlying collection
 *  does contain the item.
 *
 *  @asparam item The object to look for.
 *
 *  @asreturn true if the ICollectionView, after applying any filter,
 *  contains the item; false otherwise.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9.3
 * @export
 * @param {Object} item
 * @return {boolean}
 */
org.apache.royale.collections.IArrayListView.prototype.contains = function(item) {
};
/**
 *  Applies the sort and filter to the view.
 *  The IArrayListView does not detect changes to a sort or
 *  filter automatically, so you must call the <code>refresh()</code>
 *  method to update the view after setting the <code>sort</code>
 *  or <code>filterFunction</code> property.
 *
 *  <p>Returns <code>true</code> if the refresh was successful
 *  and <code>false</code> if the sort is not yet complete
 *  (e.g., items are still pending).
 *  A client of the view should wait for a CollectionEvent event
 *  with the <code>CollectionEventKind.REFRESH</code> <code>kind</code>
 *  property to ensure that the <code>refresh()</code> operation is
 *  complete.</p>
 *
 *  @asreturn <code>true</code> if the refresh() was complete,
 *  <code>false</code> if the refresh() is incomplete.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.9.3
 * @export
 * @return {boolean}
 */
org.apache.royale.collections.IArrayListView.prototype.refresh = function() {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.collections.IArrayListView.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IArrayListView', qName: 'org.apache.royale.collections.IArrayListView', kind: 'interface' }], interfaces: [org.apache.royale.collections.ICollectionView] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.collections.IArrayListView.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'filterFunction': { type: 'Function', access: 'readwrite', declaredBy: 'org.apache.royale.collections.IArrayListView'},
        'sort': { type: 'org.apache.royale.collections.ISort', access: 'readwrite', declaredBy: 'org.apache.royale.collections.IArrayListView'}
      };
    },
    methods: function () {
      return {
        'contains': { type: 'Boolean', declaredBy: 'org.apache.royale.collections.IArrayListView', parameters: function () { return [ 'Object', false ]; }},
        'refresh': { type: 'Boolean', declaredBy: 'org.apache.royale.collections.IArrayListView'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.collections.IArrayListView.prototype.ROYALE_COMPILE_FLAGS = 10;